#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/pgmspace.h>
#include "spi.h"
#include "lcd.h"

void lcd_clear(void)
{
	spi_putc(Escape);
	spi_putc(11);
}

void lcd_writebyte(unsigned char byte)
{
	if (byte==Escape)
		spi_putc(Escape);
	spi_putc(byte);
}

void lcd_setpixel(unsigned int x, unsigned int y)
{
	if ((x>=640)||(y>=480))
		return;
	lcd_setadress(x/8, y);
	spi_putc(Escape);
	spi_putc(16|(x&7));
}

void lcd_writetext(unsigned char *text)
{
	while (*text)
	{
		spi_putc(Escape);
		spi_putc(192);
		if (*text==Escape)
			spi_putc(Escape);
		spi_putc(*text);
		text++;
	}
}

void lcd_setadress(unsigned char x, unsigned int y)
{
	if ((x>=125)||(y>=480))
		return;
	spi_putc(Escape);
	spi_putc(1);
	if (y>=240)
		{x|=128;
		y-=240;}

	if (y==Escape)
		spi_putc(Escape);
	spi_putc(y);

	if (x==Escape)
		spi_putc(Escape);
	spi_putc(x);
}

void lcd_setpwm(unsigned char wert)
{
	spi_putc(Escape);
	spi_putc(2);

	if (wert==Escape)
		spi_putc(Escape);
	spi_putc(wert);
}

void lcd_setscroll(unsigned char wert)
{
	if (wert>=90)
		return;
	spi_putc(Escape);
	spi_putc(3);

	if (wert==Escape)
		spi_putc(Escape);
	spi_putc(wert);
}

void lcd_cleararea(unsigned char x1, unsigned char x2, unsigned int y1, unsigned int y2)
{unsigned char xscan;
unsigned int yscan;

	if ((x1>=125)||(x2>=125)||(y1>=480)||(y2>=480))
		return;

	for (yscan=y1; yscan<=y2; yscan++)
		{lcd_setadress(x1,yscan);
		for (xscan=x1; xscan<=x2; xscan++)
			spi_putc(0);
		}
}

